/****
 *
 * Exerccio de Programao 4.3
 *
 * Captulo: 4
 *
 * Demonstra: Utilize a funo ImprimeCalendario() para auxiliar
 *            na tarefa de construo do programa que resolve o.
 *            na tarefa de construo do programa que resolve o.
 *            Exerccio de Programao EP4.3
 ****/

/****
 * A funo MesEquivalente() retorna simplesmente o string
 * correspondente ao nmero do ms que recebe como entrada.
 *
 * Argumento (entrada): m - o nmero do ms
 * Retorno: O string corresponde ao ms
 *
 * NOTA: Voc no precisa modificar esta funo.
 ****/

char *MesEquivalente(unsigned  m)
{
   static  char *mes[13] = {"", "janeiro", "fevereiro", "marco", "abril",
                            "maio", "junho", "julho", "agosto", "setembro",
                            "outubro", "novembro", "dezembro"};
   if (m > 12)
      return  (char *) 0;

   return  mes[m];
}

/****
 * A funo ImprimeDia() simplesmente imprime o valor que recebe
 * como entrada. Quando o valor  menor do que 10,  adicionado
 * um espao a mais na impresso.
 *
 * Argumento (entrada): dia - o dia a ser impresso
 * Retorno: Nada
 *
 * NOTA: Voc no precisa modificar esta funo.
 ****/

void ImprimeDia(unsigned dia)
{
   if (dia < 10)
      printf("  %d", dia);
   else
      printf(" %d", dia);
}

/****
 * A funo ImprimeCalendario() imprime o calendrio para o ms desejado
 *
 * Argumentos (entrada): ms - o ms do calendrio
 *			     ano - o ano do calendrio
 *			     inicio - a ordem do dia da semana aonde comea o ms.
 *					 Os dias so numerados de 1 a 7
 * Retorno: Nada
 *
 * NOTA: Voc deve escrever a funo NumeroDeDiasNoMes().
 ****/

void ImprimeCalendario(unsigned mes, unsigned ano, unsigned inicio)
{
   char      *oMes;
   unsigned  i, diasNoMes, diasNaSemana;

   oMes = MesEquivalente(mes);
   diasNoMes = NumeroDeDiasNoMes(mes, ano);

         /* Escreva a funo NumeroDeDiasNoMes() que retorna */
         /* o nmero de dias no respectivo ms               */
   printf("\n\n%s/%d\n", oMes, ano);    printf("\n  D  S  T  Q  Q  S  S\n");

   for (i = 1; i < inicio; i++)
      printf("   ");

   for (i = 1; i <= (8 - inicio); i++)
      ImprimeDia(i);

   printf("\n");
   diasNaSemana = 1;

   for (i = 9 - inicio; i <= diasNoMes; i++){
      if (diasNaSemana > 7){
         printf("\n");
         diasNaSemana = 1;
      }
      ImprimeDia(i);
      diasNaSemana++;
   }
}
